Index: /main/waeup.uniben/trunk/src/waeup/uniben/applicants/tests.py
===================================================================
--- /main/waeup.uniben/trunk/src/waeup/uniben/applicants/tests.py	(revision 8063)
+++ /main/waeup.uniben/trunk/src/waeup/uniben/applicants/tests.py	(revision 8064)
@@ -61,7 +61,7 @@
         # Add an two different applicants containers
         self.pgcontainer = ApplicantsContainer()
-        self.pgcontainer.code = u'pg2011'
-        self.pgcontainer.prefix = u'pg'
-        self.app['applicants']['pg2011'] = self.pgcontainer
+        self.pgcontainer.code = u'pgft2011'
+        self.pgcontainer.prefix = u'pgft'
+        self.app['applicants']['pgft2011'] = self.pgcontainer
         self.ugcontainer = ApplicantsContainer()
         self.ugcontainer.code = u'app2011'
@@ -84,7 +84,7 @@
         pgapplicant.firstname = u'Anna'
         pgapplicant.lastname = u'Post'
-        self.app['applicants']['pg2011'].addApplicant(pgapplicant)
+        self.app['applicants']['pgft2011'].addApplicant(pgapplicant)
         self.pgapplication_number = pgapplicant.application_number
-        self.pgapplicant = self.app['applicants']['pg2011'][
+        self.pgapplicant = self.app['applicants']['pgft2011'][
             self.pgapplication_number]
 
@@ -108,5 +108,5 @@
     def test_manage_and_view_applicant(self):
         # Managers can manage pg applicants
-        pgapplicant_path = ('http://localhost/app/applicants/pg2011/%s'
+        pgapplicant_path = ('http://localhost/app/applicants/pgft2011/%s'
             % self.pgapplication_number)
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
Index: /main/waeup.uniben/trunk/src/waeup/uniben/applicants/utils.py
===================================================================
--- /main/waeup.uniben/trunk/src/waeup/uniben/applicants/utils.py	(revision 8063)
+++ /main/waeup.uniben/trunk/src/waeup/uniben/applicants/utils.py	(revision 8064)
@@ -38,5 +38,6 @@
         'dp': ['Diploma Programmes', 'DPP'],
         'pce': ['PCE Screening', 'PCE'],
-        'pg': ['Postgraduate Programmes', 'PCE']
+        'pgft': ['Postgraduate Full-Time Programmes', 'PG'],
+        'pgpt': ['Postgraduate Part-Time Programmes', 'PG']
         }
 
Index: /main/waeup.uniben/trunk/src/waeup/uniben/utils/utils.py
===================================================================
--- /main/waeup.uniben/trunk/src/waeup/uniben/utils/utils.py	(revision 8063)
+++ /main/waeup.uniben/trunk/src/waeup/uniben/utils/utils.py	(revision 8064)
@@ -19,5 +19,5 @@
 """
 import os
-from waeup.kofa.utils.utils import KofaUtils
+from waeup.kofa.utils.utils import KofaUtils, sorted_phone_prefixes
 from waeup.kofa.accesscodes import create_accesscode
 from waeup.uniben.interfaces import MessageFactory as _
@@ -51,4 +51,14 @@
     return
 
+INT_PHONE_PREFIXES = [
+    (99, _('Germany'), '49'),
+    ( 1, _('Nigeria'), '234'),
+    (99, _('United States'), '1'),
+    (99, _('Niger'), '234'),
+    (99, _('Benin'), '229'),
+    (99, _('Cameroon'), '237'),
+    (99, _('United Kingdom'), '44'),
+    (99, _('France'), '33'),
+    ]
 
 class KofaUtils(KofaUtils):
@@ -57,12 +67,12 @@
     PORTAL_LANGUAGE = 'en'
 
+    # We do not dosplay the language selector at the moment.
     PREFERRED_LANGUAGES_DICT = {
-        'en':(1, u'English'),
-        'fr':(2, u'Fran&ccedil;ais'),
-        'de':(3, u'Deutsch'),
-        'ha':(4, u'Hausa'),
-        'yo':(5, u'Yoruba'),
-        'ig':(6, u'Igbo'),
-        }
+        }
+
+    #: A function to return
+    @classmethod
+    def sorted_phone_prefixes(cls, data=INT_PHONE_PREFIXES, request=None):
+        return sorted_phone_prefixes(data, request)
 
     EXAM_SUBJECTS_DICT = {
@@ -200,5 +210,6 @@
         'basic': 'PUME, PDE, PCE, PRENCE',
         'no': 'no application',
-        'pg': 'Postgraduate',
+        'pg_ft': 'Postgraduate Full-Time',
+        'pg_pt': 'Postgraduate Part-Time',
         'sandwich': 'Sandwich',
         'cest': 'Part-Time, Diploma, Certificate'