Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/interfaces.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/interfaces.py	(revision 8059)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/interfaces.py	(revision 8069)
@@ -34,6 +34,5 @@
 from waeup.kofa.payments.interfaces import IOnlinePayment
 from waeup.kofa.schoolgrades import ResultEntryField
-from waeup.kofa.students.vocabularies import (
-    lgas_vocab, GenderSource)
+from waeup.kofa.students.vocabularies import GenderSource
 from waeup.kofa.university.vocabularies import (
     course_levels, AppCatSource, CertificateSource)
@@ -343,10 +342,4 @@
         required = True,
         )
-    lga = schema.Choice(
-        source = lgas_vocab,
-        title = _(u'State/LGA'),
-        default = 'foreigner',
-        required = False,
-        )
     sex = schema.Choice(
         title = _(u'Sex'),
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 8059)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 8069)
@@ -157,5 +157,4 @@
         self.browser.getControl(name="form.course1").value = ['CERT1']
         self.browser.getControl(name="form.date_of_birth").value = '09/09/1988'
-        self.browser.getControl(name="form.lga").value = ['foreigner']
         self.browser.getControl(name="form.sex").value = ['m']
         self.browser.getControl(name="form.email").value = 'xx@yy.zz'
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_export.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_export.py	(revision 8059)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_export.py	(revision 8069)
@@ -140,5 +140,5 @@
             'applicant_id,application_date,application_number,course1,course2,'
             'course_admitted,date_of_birth,display_fullname,email,firstname,'
-            'history,lastname,lga,locked,middlename,notice,password,phone,'
+            'history,lastname,locked,middlename,notice,password,phone,'
             'reg_number,screening_score,screening_venue,sex,state,'
             'student_id\r\n'
@@ -147,5 +147,5 @@
         self.assertTrue(
             'Application initialized by system\'],Tester,'
-            'foreigner,0,,,,,,,,,initialized,\r\n'
+            '0,,,,,,,,,initialized,\r\n'
             in result)
         return
@@ -164,5 +164,5 @@
             'applicant_id,application_date,application_number,course1,course2,'
             'course_admitted,date_of_birth,display_fullname,email,firstname,'
-            'history,lastname,lga,locked,middlename,notice,password,phone,'
+            'history,lastname,locked,middlename,notice,password,phone,'
             'reg_number,screening_score,screening_venue,sex,state,'
             'student_id\r\n'
@@ -172,5 +172,5 @@
         self.assertTrue(
             'Application initialized by system\'],'
-            'Tester,foreigner,0,M.,"Some notice\nin lines.",any password,'
+            'Tester,0,M.,"Some notice\nin lines.",any password,'
             '+234-123-12345,123456,98,Exam Room,f,initialized,\r\n'
             in result)
@@ -188,5 +188,5 @@
             'applicant_id,application_date,application_number,course1,course2,'
             'course_admitted,date_of_birth,display_fullname,email,firstname,'
-            'history,lastname,lga,locked,middlename,notice,password,phone,'
+            'history,lastname,locked,middlename,notice,password,phone,'
             'reg_number,screening_score,screening_venue,sex,state,'
             'student_id\r\n'
@@ -196,5 +196,5 @@
         self.assertTrue(
             'Application initialized by system\'],'
-            'Tester,foreigner,0,M.,"Some notice\nin lines.",any password,'
+            'Tester,0,M.,"Some notice\nin lines.",any password,'
             '+234-123-12345,123456,98,Exam Room,f,initialized,\r\n'
             in result)