Index: /main/waeup.custom/trunk/src/waeup/custom/applicants/browser.py
===================================================================
--- /main/waeup.custom/trunk/src/waeup/custom/applicants/browser.py	(revision 8076)
+++ /main/waeup.custom/trunk/src/waeup/custom/applicants/browser.py	(revision 8077)
@@ -22,5 +22,5 @@
     FriendlyDateWidget, FriendlyDateDisplayWidget,
     FriendlyDatetimeDisplayWidget)
-from waeup.kofa.widgets.phonewidget import PhoneWidget
+from waeup.custom.widgets.phonewidget import PhoneWidget
 from waeup.kofa.applicants.browser import (ApplicantDisplayFormPage,
     OnlinePaymentCallbackPage, ExportPDFPage,
@@ -93,5 +93,4 @@
         form_fields['student_id'].for_display = True
         form_fields['applicant_id'].for_display = True
-        form_fields['phone'].custom_widget = PhoneWidget
         return form_fields
 
Index: /main/waeup.custom/trunk/src/waeup/custom/students/browser.py
===================================================================
--- /main/waeup.custom/trunk/src/waeup/custom/students/browser.py	(revision 8076)
+++ /main/waeup.custom/trunk/src/waeup/custom/students/browser.py	(revision 8077)
@@ -25,11 +25,13 @@
     StudentClearanceManageFormPage, StudentClearanceEditFormPage,
     StudentClearanceDisplayFormPage, OnlinePaymentCallbackPage,
-    ExportPDFClearanceSlipPage)
+    ExportPDFClearanceSlipPage, StudentBaseManageFormPage,
+    StudentBaseEditFormPage)
 from waeup.kofa.students.viewlets import RequestCallbackActionButton
 from waeup.custom.students.interfaces import (
-    IStudent, IStudentPersonal,
+    IStudentBase, IStudent, IStudentPersonal,
     IUGStudentClearance,IPGStudentClearance,
     )
 from waeup.custom.interfaces import MessageFactory as _
+from waeup.custom.widgets.phonewidget import PhoneWidget
 
 class RequestCallbackActionButton(RequestCallbackActionButton):
@@ -45,4 +47,17 @@
     def update(self):
         return
+
+class StudentBaseManageFormPage(StudentBaseManageFormPage):
+    """ View to manage student base data
+    """
+    form_fields = grok.AutoFields(IStudentBase).omit('student_id')
+    form_fields['phone'].custom_widget = PhoneWidget
+
+class StudentBaseEditFormPage(StudentBaseEditFormPage):
+    """ View to edit student base data
+    """
+    form_fields = grok.AutoFields(IStudentBase).select(
+        'email', 'phone')
+    form_fields['phone'].custom_widget = PhoneWidget
 
 class StudentPersonalDisplayFormPage(StudentPersonalDisplayFormPage):
Index: /main/waeup.custom/trunk/src/waeup/custom/widgets/__init__.py
===================================================================
--- /main/waeup.custom/trunk/src/waeup/custom/widgets/__init__.py	(revision 8077)
+++ /main/waeup.custom/trunk/src/waeup/custom/widgets/__init__.py	(revision 8077)
@@ -0,0 +1,1 @@
+# Make this a package.
Index: /main/waeup.custom/trunk/src/waeup/custom/widgets/phonewidget.py
===================================================================
--- /main/waeup.custom/trunk/src/waeup/custom/widgets/phonewidget.py	(revision 8077)
+++ /main/waeup.custom/trunk/src/waeup/custom/widgets/phonewidget.py	(revision 8077)
@@ -0,0 +1,27 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""
+A customized phone widget
+"""
+
+from waeup.kofa.widgets.phonewidget import PhoneWidget
+
+class PhoneWidget(PhoneWidget):
+
+    subwidget_names = ('country', 'ext')
+    bootstrap_span = 'span3'