Index: main/waeup.uniben/trunk/src/waeup/uniben/applicants/interfaces.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/applicants/interfaces.py	(revision 8093)
+++ main/waeup.uniben/trunk/src/waeup/uniben/applicants/interfaces.py	(revision 8101)
@@ -26,50 +26,7 @@
 from waeup.kofa.interfaces import SimpleKofaVocabulary
 from waeup.kofa.students.vocabularies import nats_vocab
-from waeup.uniben.interfaces import lgas_vocab
+from waeup.uniben.interfaces import (
+    lgas_vocab, high_qual, high_grade, exam_types)
 from waeup.uniben.interfaces import MessageFactory as _
-
-high_qual = SimpleKofaVocabulary(
-    ('National Certificate of Education','nce'),
-    ('Pre Degree Programme','pre'),
-    ('Diploma Programme','dip'),
-    ('Ordinary National Diploma','ond'),
-    ('Bachelors Degree','bd'),
-    ('Masters Degree','md'),
-    ('Professional Qualification','pq'),
-    ('Other Certification','oc'),
-    ('Higher National Diploma','hnd'),
-    ('NCE AL OTH','nce_al_oth'),
-    ('National Defence Academy','nda'),
-    ('Awaiting Results','a_rslt'),
-    ('RMC','rmc'),
-    )
-
-high_grade = SimpleKofaVocabulary(
-    ('Upper Credit','upper_credit'),
-    ('Distinction','distinction'),
-    ('Credit','credit'),
-    ('Merit','merit'),
-    ('Lower Credit','lower_credit'),
-    ('First Class','first_class'),
-    ('Second Class Upper','second_class_upper'),
-    ('Second Class Lower','second_class_lower'),
-    ('Third Class','third_class'),
-    ('Pass','pass'),
-    ('Awaiting Results','a_rslt'),
-    ('A Levels','al'),
-    )
-
-exam_types = SimpleKofaVocabulary(
-    ('SSCE','ssce'),
-    ('WAEC','waec'),
-    ('GCE O\' LEVEL','gce_o_level'),
-    ('TC II','tc_ii'),
-    ('RSA','rsa'),
-    ('NABTEB','nabteb'),
-    ('NECO','neco'),
-    ('ACE','ace'),
-    ('GCE A\' LEVEL','gce_a_level'),
-    ('IGCSE','igcse'),
-    )
 
 class IUGApplicant(IApplicantBaseData):
@@ -162,4 +119,24 @@
         readonly = False,
         vocabulary = exam_types,
+        )
+    #presently = schema.Bool(
+    #    title = _(u'Attending'),
+    #    required = False,
+    #    readonly = False,
+    #    )
+    presently_inst = schema.TextLine(
+        title = _(u'If yes, name of institution'),
+        required = False,
+        readonly = False,
+        )
+    nysc_year = schema.Int(
+        title = _(u'Nysc Year'),
+        required = False,
+        readonly = False,
+        )
+    nysc_lga = schema.Choice(
+        source = lgas_vocab,
+        title = _(u'Nysc Location'),
+        required = False,
         )
     employer = schema.TextLine(
Index: main/waeup.uniben/trunk/src/waeup/uniben/applicants/utils.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/applicants/utils.py	(revision 8093)
+++ main/waeup.uniben/trunk/src/waeup/uniben/applicants/utils.py	(revision 8101)
@@ -48,6 +48,7 @@
         'form.presently': _(u'Course or Programme Presently Attending'),
         'form.nysc_year': _(u'NYSC Information'),
-        'form.employer': _(u'Employer History'),
+        'form.employer': _(u'Employment History'),
         'form.notice': _(u'Application Process Information'),
         'form.pp_school': _(u'Post Primary School Qualification'),
+        'form.presently_inst': _(u'Presently attending a course or programme'),
         }
Index: main/waeup.uniben/trunk/src/waeup/uniben/interfaces.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/interfaces.py	(revision 8093)
+++ main/waeup.uniben/trunk/src/waeup/uniben/interfaces.py	(revision 8101)
@@ -24,4 +24,49 @@
 
 _ = MessageFactory = zope.i18nmessageid.MessageFactory('waeup.uniben')
+
+high_qual = SimpleKofaVocabulary(
+    ('National Certificate of Education','nce'),
+    ('Pre Degree Programme','pre'),
+    ('Diploma Programme','dip'),
+    ('Ordinary National Diploma','ond'),
+    ('Bachelors Degree','bd'),
+    ('Masters Degree','md'),
+    ('Professional Qualification','pq'),
+    ('Other Certification','oc'),
+    ('Higher National Diploma','hnd'),
+    ('NCE AL OTH','nce_al_oth'),
+    ('National Defence Academy','nda'),
+    ('Awaiting Results','a_rslt'),
+    ('RMC','rmc'),
+    )
+
+high_grade = SimpleKofaVocabulary(
+    ('Upper Credit','upper_credit'),
+    ('Distinction','distinction'),
+    ('Credit','credit'),
+    ('Merit','merit'),
+    ('Lower Credit','lower_credit'),
+    ('First Class','first_class'),
+    ('Second Class Upper','second_class_upper'),
+    ('Second Class Lower','second_class_lower'),
+    ('Third Class','third_class'),
+    ('Pass','pass'),
+    ('Awaiting Results','a_rslt'),
+    ('A Levels','al'),
+    )
+
+exam_types = SimpleKofaVocabulary(
+    ('SSCE','ssce'),
+    ('WAEC','waec'),
+    ('GCE O\' LEVEL','gce_o_level'),
+    ('TC II','tc_ii'),
+    ('RSA','rsa'),
+    ('NABTEB','nabteb'),
+    ('NECO','neco'),
+    ('ACE','ace'),
+    ('GCE A\' LEVEL','gce_a_level'),
+    ('IGCSE','igcse'),
+    )
+
 
 lgas_vocab = SimpleKofaVocabulary(
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/interfaces.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/interfaces.py	(revision 8093)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/interfaces.py	(revision 8101)
@@ -19,4 +19,5 @@
 from waeup.kofa.schema import TextLineChoice
 from waeup.kofa.interfaces import SimpleKofaVocabulary
+from waeup.kofa.schoolgrades import ResultEntryField
 from waeup.kofa.students.vocabularies import nats_vocab
 from waeup.kofa.students.interfaces import (
@@ -26,5 +27,6 @@
 from waeup.kofa.students.vocabularies import (
     nats_vocab, contextual_reg_num_source)
-from waeup.uniben.interfaces import lgas_vocab
+from waeup.uniben.interfaces import (
+    lgas_vocab, high_qual, high_grade, exam_types)
 from waeup.uniben.interfaces import MessageFactory as _
 
@@ -76,4 +78,132 @@
         )
 
+    fst_sit_fname = schema.TextLine(
+        title = _(u'Full Name'),
+        required = False,
+        readonly = False,
+        )
+    fst_sit_no = schema.TextLine(
+        title = _(u'Exam Number'),
+        required = False,
+        readonly = False,
+        )
+
+    fst_sit_date = schema.Date(
+        title = _(u'Exam Date'),
+        required = False,
+        readonly = False,
+        )
+
+    fst_sit_type = schema.Choice(
+        title = _(u'Exam Type'),
+        required = False,
+        readonly = False,
+        vocabulary = exam_types,
+        )
+
+    fst_sit_results = schema.List(
+        title = _(u'Exam Results'),
+        value_type = ResultEntryField(),
+        required = False,
+        readonly = False,
+        default = [],
+        )
+
+    scd_sit_fname = schema.TextLine(
+        title = _(u'Full Name'),
+        required = False,
+        readonly = False,
+        )
+    scd_sit_no = schema.TextLine(
+        title = _(u'Exam Number'),
+        required = False,
+        readonly = False,
+        )
+
+    scd_sit_date = schema.Date(
+        title = _(u'Exam Date'),
+        required = False,
+        readonly = False,
+        )
+
+    scd_sit_type = schema.Choice(
+        title = _(u'Exam Type'),
+        required = False,
+        readonly = False,
+        vocabulary = exam_types,
+        )
+
+    scd_sit_results = schema.List(
+        title = _(u'Exam Results'),
+        value_type = ResultEntryField(),
+        required = False,
+        readonly = False,
+        default = [],
+        )
+
+    alr_fname = schema.TextLine(
+        title = _(u'Full Name'),
+        required = False,
+        readonly = False,
+        )
+    alr_no = schema.TextLine(
+        title = _(u'Exam Number'),
+        required = False,
+        readonly = False,
+        )
+
+    alr_date = schema.Date(
+        title = _(u'Exam Date'),
+        required = False,
+        readonly = False,
+        )
+
+    alr_results = schema.List(
+        title = _(u'Exam Results'),
+        value_type = ResultEntryField(),
+        required = False,
+        readonly = False,
+        default = [],
+        )
+
+    hq_type = schema.Choice(
+        title = _(u'Qualification Obtained'),
+        required = False,
+        readonly = False,
+        vocabulary = high_qual,
+        )
+
+    hq_matric_no = schema.TextLine(
+        title = _(u'Former Matric Number'),
+        required = False,
+        readonly = False,
+        )
+
+    hq_degree = schema.Choice(
+        title = _(u'Class of Degree'),
+        required = False,
+        readonly = False,
+        vocabulary = high_grade,
+        )
+
+    hq_school = schema.TextLine(
+        title = _(u'Institution Attended'),
+        required = False,
+        readonly = False,
+        )
+
+    hq_session = schema.TextLine(
+        title = _(u'Years Attended'),
+        required = False,
+        readonly = False,
+        )
+
+    hq_disc = schema.TextLine(
+        title = _(u'Discipline'),
+        required = False,
+        readonly = False,
+        )
+
+
 class IPGStudentClearance(IUGStudentClearance):
     """Representation of pg student clearance data.
@@ -81,4 +211,114 @@
     """
 
+    hq2_type = schema.Choice(
+        title = _(u'Qualification Obtained'),
+        required = False,
+        readonly = False,
+        vocabulary = high_qual,
+        )
+
+    hq2_matric_no = schema.TextLine(
+        title = _(u'Former Matric Number'),
+        required = False,
+        readonly = False,
+        )
+
+    hq2_degree = schema.Choice(
+        title = _(u'Class of Degree'),
+        required = False,
+        readonly = False,
+        vocabulary = high_grade,
+        )
+
+    hq2_school = schema.TextLine(
+        title = _(u'Institution Attended'),
+        required = False,
+        readonly = False,
+        )
+
+    hq2_session = schema.TextLine(
+        title = _(u'Years Attended'),
+        required = False,
+        readonly = False,
+        )
+
+    hq2_disc = schema.TextLine(
+        title = _(u'Discipline'),
+        required = False,
+        readonly = False,
+        )
+
+    nysc_year = schema.Int(
+        title = _(u'Nysc Year'),
+        required = False,
+        readonly = False,
+        )
+
+    nysc_lga = schema.Choice(
+        source = lgas_vocab,
+        title = _(u'Nysc Location'),
+        required = False,
+        )
+
+    employer = schema.TextLine(
+        title = _(u'Employer'),
+        required = False,
+        readonly = False,
+        )
+
+    emp_position = schema.TextLine(
+        title = _(u'Employer Position'),
+        required = False,
+        readonly = False,
+        )
+
+    emp_start = schema.Date(
+        title = _(u'Start Date'),
+        required = False,
+        readonly = False,
+        )
+
+    emp_end = schema.Date(
+        title = _(u'End Date'),
+        required = False,
+        readonly = False,
+        )
+
+    emp_reason = schema.TextLine(
+        title = _(u'Reason for Leaving'),
+        required = False,
+        readonly = False,
+        )
+
+    employer2 = schema.TextLine(
+        title = _(u'2nd Employer'),
+        required = False,
+        readonly = False,
+        )
+
+    emp2_position = schema.TextLine(
+        title = _(u'2nd Employer Position'),
+        required = False,
+        readonly = False,
+        )
+
+    emp2_start = schema.Date(
+        title = _(u'Start Date'),
+        required = False,
+        readonly = False,
+        )
+    emp2_end = schema.Date(
+        title = _(u'End Date'),
+        required = False,
+        readonly = False,
+        )
+
+    emp2_reason = schema.TextLine(
+        title = _(u'Reason for Leaving'),
+        required = False,
+        readonly = False,
+        )
+
+
 class IStudent(IStudentBase,IUGStudentClearance,IPGStudentClearance,IStudentPersonal):
     """Representation of a student.
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/utils.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/utils.py	(revision 8093)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/utils.py	(revision 8101)
@@ -121,2 +121,12 @@
         'A8': 'Merit',
         }
+
+    SEPARATORS_DICT = {
+        'form.fst_sit_fname': _(u'First Sitting Recod'),
+        'form.scd_sit_fname': _(u'Second Sitting Record'),
+        'form.alr_fname': _(u'Advanced Level Record'),
+        'form.hq_type': _(u'Higher Education Record'),
+        'form.hq2_type': _(u'Second Higher Education Record'),
+        'form.nysc_year': _(u'NYSC Information'),
+        'form.employer': _(u'Employment History'),
+        }