Index: main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py	(revision 8107)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py	(revision 8108)
@@ -85,7 +85,15 @@
         if cm is not None and cm.startswith('pg'):
             form_fields = grok.AutoFields(IPGStudentClearance).omit('clearance_locked')
+            form_fields['emp_start'].custom_widget = FriendlyDateDisplayWidget('le')
+            form_fields['emp_end'].custom_widget = FriendlyDateDisplayWidget('le')
+            form_fields['emp2_start'].custom_widget = FriendlyDateDisplayWidget('le')
+            form_fields['emp2_end'].custom_widget = FriendlyDateDisplayWidget('le')
         else:
             form_fields = grok.AutoFields(IUGStudentClearance).omit('clearance_locked')
         form_fields['date_of_birth'].custom_widget = FriendlyDateDisplayWidget('le')
+        form_fields['fst_sit_date'].custom_widget = FriendlyDateDisplayWidget('le')
+        form_fields['scd_sit_date'].custom_widget = FriendlyDateDisplayWidget('le')
+        form_fields['scd_sit_date'].custom_widget = FriendlyDateDisplayWidget('le')
+        form_fields['alr_date'].custom_widget = FriendlyDateDisplayWidget('le')
         return form_fields
 
@@ -100,7 +108,15 @@
         if cm is not None and cm.startswith('pg'):
             form_fields = grok.AutoFields(IPGStudentClearance).omit('clearance_locked')
+            form_fields['emp_start'].custom_widget = FriendlyDateWidget('le-year')
+            form_fields['emp_end'].custom_widget = FriendlyDateWidget('le-year')
+            form_fields['emp2_start'].custom_widget = FriendlyDateWidget('le-year')
+            form_fields['emp2_end'].custom_widget = FriendlyDateWidget('le-year')
         else:
             form_fields = grok.AutoFields(IUGStudentClearance).omit('clearance_locked')
         form_fields['date_of_birth'].custom_widget = FriendlyDateDisplayWidget('le')
+        form_fields['fst_sit_date'].custom_widget = FriendlyDateWidget('le-year')
+        form_fields['scd_sit_date'].custom_widget = FriendlyDateWidget('le-year')
+        form_fields['scd_sit_date'].custom_widget = FriendlyDateWidget('le-year')
+        form_fields['alr_date'].custom_widget = FriendlyDateWidget('le-year')
         return form_fields
 
@@ -115,7 +131,17 @@
         if cm is not None and cm.startswith('pg'):
             form_fields = grok.AutoFields(IPGStudentClearance)
+            form_fields['emp_start'].custom_widget = FriendlyDateWidget('le-year')
+            form_fields['emp_end'].custom_widget = FriendlyDateWidget('le-year')
+            form_fields['emp2_start'].custom_widget = FriendlyDateWidget('le-year')
+            form_fields['emp2_end'].custom_widget = FriendlyDateWidget('le-year')
         else:
             form_fields = grok.AutoFields(IUGStudentClearance)
         form_fields['date_of_birth'].custom_widget = FriendlyDateWidget('le-year')
+        form_fields['fst_sit_date'].custom_widget = FriendlyDateWidget('le-year')
+        form_fields['scd_sit_date'].custom_widget = FriendlyDateWidget('le-year')
+        form_fields['scd_sit_date'].custom_widget = FriendlyDateWidget('le-year')
+        form_fields['alr_date'].custom_widget = FriendlyDateWidget('le-year')
+
+
         return form_fields
 
@@ -130,7 +156,15 @@
         if cm is not None and cm.startswith('pg'):
             form_fields = grok.AutoFields(IPGStudentClearance).omit('clearance_locked')
+            form_fields['emp_start'].custom_widget = FriendlyDateWidget('le-year')
+            form_fields['emp_end'].custom_widget = FriendlyDateWidget('le-year')
+            form_fields['emp2_start'].custom_widget = FriendlyDateWidget('le-year')
+            form_fields['emp2_end'].custom_widget = FriendlyDateWidget('le-year')
         else:
             form_fields = grok.AutoFields(IUGStudentClearance).omit('clearance_locked')
         form_fields['date_of_birth'].custom_widget = FriendlyDateWidget('le-year')
+        form_fields['fst_sit_date'].custom_widget = FriendlyDateWidget('le-year')
+        form_fields['scd_sit_date'].custom_widget = FriendlyDateWidget('le-year')
+        form_fields['scd_sit_date'].custom_widget = FriendlyDateWidget('le-year')
+        form_fields['alr_date'].custom_widget = FriendlyDateWidget('le-year')
         return form_fields
 
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/viewlets.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/viewlets.py	(revision 8107)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/viewlets.py	(revision 8108)
@@ -32,5 +32,5 @@
     label = _(u'LGA Identification')
     title = _(u'LGA Identification Scan')
-    download_name = u'lga_identification'
+    download_name = u'lga_ident'
 
 class LGAIdentificationSlip(LGAIdentificationDisplay):
@@ -44,5 +44,5 @@
     title = _(u'LGA Identification Scan')
     mus = 1024 * 150
-    download_name = u'lga_identification'
+    download_name = u'lga_ident'
     tab_redirect = '?tab2'
 
@@ -50,4 +50,149 @@
     """Renders LGA Identification scan.
     """
-    grok.name('lga_identification')
-    download_name = u'lga_identification'
+    grok.name('lga_ident')
+    download_name = u'lga_ident'
+
+# First Sitting Result
+
+class FirstSittingResultDisplay(FileDisplay):
+    """First Sitting Result display viewlet.
+    """
+    grok.order(1)
+    label = _(u'First Sitting Result')
+    title = _(u'First Sitting Result')
+    download_name = u'fst_sit_scan'
+
+class FirstSittingResultSlip(FirstSittingResultDisplay):
+    grok.view(ExportPDFClearanceSlipPage)
+
+class FirstSittingResultUpload(FileUpload):
+    """First Sitting Result upload viewlet.
+    """
+    grok.order(2)
+    label = _(u'First Sitting Result')
+    title = _(u'First Sitting Result Scan')
+    mus = 1024 * 150
+    download_name = u'fst_sit_scan'
+    tab_redirect = '?tab2'
+
+class FirstSittingResultImage(Image):
+    """Renders First Sitting Result scan.
+    """
+    grok.name('fst_sit_scan')
+    download_name = u'fst_sit_scan'
+
+# Second Sitting Result
+
+class SecondSittingResultDisplay(FileDisplay):
+    """Second Sitting Result display viewlet.
+    """
+    grok.order(1)
+    label = _(u'Second Sitting Result')
+    title = _(u'Second Sitting Result')
+    download_name = u'scd_sit_scan'
+
+class SecondSittingResultSlip(SecondSittingResultDisplay):
+    grok.view(ExportPDFClearanceSlipPage)
+
+class SecondSittingResultUpload(FileUpload):
+    """Second Sitting Result upload viewlet.
+    """
+    grok.order(2)
+    label = _(u'Second Sitting Result')
+    title = _(u'Second Sitting Result Scan')
+    mus = 1024 * 150
+    download_name = u'scd_sit_scan'
+    tab_redirect = '?tab2'
+
+class SecondSittingResultImage(Image):
+    """Renders Second Sitting Result scan.
+    """
+    grok.name('scd_sit_scan')
+    download_name = u'scd_sit_scan'
+
+# Higher Qualification Result
+
+class HigherQualificationResultDisplay(FileDisplay):
+    """Higher Qualification Result display viewlet.
+    """
+    grok.order(1)
+    label = _(u'Higher Qualification Result')
+    title = _(u'Higher Qualification Result')
+    download_name = u'hq_scan'
+
+class HigherQualificationResultSlip(HigherQualificationResultDisplay):
+    grok.view(ExportPDFClearanceSlipPage)
+
+class HigherQualificationResultUpload(FileUpload):
+    """Higher Qualification Result upload viewlet.
+    """
+    grok.order(2)
+    label = _(u'Higher Qualification Result')
+    title = _(u'Higher Qualification Result Scan')
+    mus = 1024 * 150
+    download_name = u'hq_scan'
+    tab_redirect = '?tab2'
+
+class HigherQualificationResultImage(Image):
+    """Renders Higher Qualification Result scan.
+    """
+    grok.name('hq_scan')
+    download_name = u'hq_scan'
+
+# 2nd Higher Qualification Result
+
+class SecondHigherQualificationResultDisplay(FileDisplay):
+    """Second Higher Qualification Result display viewlet.
+    """
+    grok.order(1)
+    label = _(u'Second Higher Qualification Result')
+    title = _(u'Second Higher Qualification Result')
+    download_name = u'hq_scan2'
+
+class SecondHigherQualificationResultSlip(SecondHigherQualificationResultDisplay):
+    grok.view(ExportPDFClearanceSlipPage)
+
+class SecondHigherQualificationResultUpload(FileUpload):
+    """Second Higher Qualification Result upload viewlet.
+    """
+    grok.order(2)
+    label = _(u'Second Higher Qualification Result')
+    title = _(u'Second Higher Qualification Result Scan')
+    mus = 1024 * 150
+    download_name = u'hq_scan2'
+    tab_redirect = '?tab2'
+
+class SecondHigherQualificationResultImage(Image):
+    """Renders Second Higher Qualification Result scan.
+    """
+    grok.name('hq_scan2')
+    download_name = u'hq_scan2'
+
+# Evidence of Name
+
+class EvidenceOfNameDisplay(FileDisplay):
+    """Evidence of Name display viewlet.
+    """
+    grok.order(1)
+    label = _(u'Evidence of Name')
+    title = _(u'Evidence of Name')
+    download_name = u'evid'
+
+class EvidenceOfNameSlip(EvidenceOfNameDisplay):
+    grok.view(ExportPDFClearanceSlipPage)
+
+class EvidenceOfNameUpload(FileUpload):
+    """Evidence of Name upload viewlet.
+    """
+    grok.order(2)
+    label = _(u'Evidence of Name')
+    title = _(u'Evidence of Name Scan')
+    mus = 1024 * 150
+    download_name = u'evid'
+    tab_redirect = '?tab2'
+
+class EvidenceOfNameImage(Image):
+    """Renders Evidence of Name scan.
+    """
+    grok.name('evid')
+    download_name = u'evid'