Index: main/waeup.uniben/trunk/src/waeup/uniben/etranzact/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/etranzact/browser.py	(revision 8128)
+++ main/waeup.uniben/trunk/src/waeup/uniben/etranzact/browser.py	(revision 8129)
@@ -109,5 +109,5 @@
             return
 
-        if success_dict.get('PAYMENT_CODE') != self.context.p_id:
+        if success_dict.get('COL1') != self.context.p_id:
             self.flash(_('Wrong transaction id'))
             write_log_message(
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py	(revision 8128)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py	(revision 8129)
@@ -22,5 +22,5 @@
     )
 from waeup.kofa.students.browser import (
-    StudentPersonalDisplayFormPage, StudentPersonalManageFormPage,
+    StudentPersonalDisplayFormPage,
     StudentClearanceManageFormPage, StudentClearanceEditFormPage,
     StudentClearanceDisplayFormPage, OnlinePaymentCallbackPage,
@@ -69,9 +69,4 @@
     form_fields['perm_address'].custom_widget = BytesDisplayWidget
 
-class StudentPersonalManageFormPage(StudentPersonalManageFormPage):
-    """ Page to edit student clearance data
-    """
-    grok.context(IStudent)
-    form_fields = grok.AutoFields(IStudentPersonal)
 
 class StudentClearanceDisplayFormPage(StudentClearanceDisplayFormPage):
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/viewlets.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/viewlets.py	(revision 8128)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/viewlets.py	(revision 8129)
@@ -45,5 +45,4 @@
     mus = 1024 * 150
     download_name = u'lga_ident'
-    tab_redirect = '?tab2'
 
 class LGAIdentificationImage(Image):
@@ -74,5 +73,4 @@
     mus = 1024 * 150
     download_name = u'fst_sit_scan'
-    tab_redirect = '?tab2'
 
 class FirstSittingResultImage(Image):
@@ -103,5 +101,4 @@
     mus = 1024 * 150
     download_name = u'scd_sit_scan'
-    tab_redirect = '?tab2'
 
 class SecondSittingResultImage(Image):
@@ -132,5 +129,4 @@
     mus = 1024 * 150
     download_name = u'hq_scan'
-    tab_redirect = '?tab2'
 
 class HigherQualificationResultImage(Image):
@@ -161,5 +157,4 @@
     mus = 1024 * 150
     download_name = u'hq_scan2'
-    tab_redirect = '?tab2'
 
 class SecondHigherQualificationResultImage(Image):
@@ -168,4 +163,116 @@
     grok.name('hq_scan2')
     download_name = u'hq_scan2'
+
+# Advanced Level Result
+
+class AdvancedLevelResultDisplay(FileDisplay):
+    """Advanced Level Result display viewlet.
+    """
+    grok.order(1)
+    label = _(u'Advanced Level Result')
+    title = _(u'Advanced Level Result')
+    download_name = u'alr_scan'
+
+class AdvancedLevelResultSlip(AdvancedLevelResultDisplay):
+    grok.view(ExportPDFClearanceSlipPage)
+
+class AdvancedLevelResultUpload(FileUpload):
+    """Advanced Level Result upload viewlet.
+    """
+    grok.order(2)
+    label = _(u'Advanced Level Result')
+    title = _(u'Advanced Level Result Scan')
+    mus = 1024 * 150
+    download_name = u'alr_scan'
+
+class AdvancedLevelResultImage(Image):
+    """Renders Advanced Level Result scan.
+    """
+    grok.name('alr_scan')
+    download_name = u'alr_scan'
+
+# Certificate 
+
+class CertificateDisplay(FileDisplay):
+    """Certificate display viewlet.
+    """
+    grok.order(1)
+    label = _(u'Certificate')
+    title = _(u'Certificate')
+    download_name = u'certificate'
+
+class CertificateSlip(CertificateDisplay):
+    grok.view(ExportPDFClearanceSlipPage)
+
+class CertificateUpload(FileUpload):
+    """Certificate upload viewlet.
+    """
+    grok.order(2)
+    label = _(u'Certificate')
+    title = _(u'Certificate Scan')
+    mus = 1024 * 150
+    download_name = u'certificate'
+
+class CertificateImage(Image):
+    """Renders Certificate scan.
+    """
+    grok.name('certificate')
+    download_name = u'certificate'
+
+# Second Certificate
+
+class SecondCertificateDisplay(FileDisplay):
+    """ Second Certificate display viewlet.
+    """
+    grok.order(1)
+    label = _(u'Second Certificate')
+    title = _(u'Second Certificate')
+    download_name = u'certificate2'
+
+class SecondCertificateSlip(SecondCertificateDisplay):
+    grok.view(ExportPDFClearanceSlipPage)
+
+class SecondCertificateUpload(FileUpload):
+    """Second Certificate upload viewlet.
+    """
+    grok.order(2)
+    label = _(u'Second Certificate')
+    title = _(u'Second Certificate Scan')
+    mus = 1024 * 150
+    download_name = u'certificate2'
+
+class CertificateImage(Image):
+    """Renders Second Certificate scan.
+    """
+    grok.name('certificate2')
+    download_name = u'certificate2'
+
+# Third Certificate
+
+class ThirdCertificateDisplay(FileDisplay):
+    """ Third Certificate display viewlet.
+    """
+    grok.order(1)
+    label = _(u'Third Certificate')
+    title = _(u'Third Certificate')
+    download_name = u'certificate3'
+
+class ThirdCertificateSlip(ThirdCertificateDisplay):
+    grok.view(ExportPDFClearanceSlipPage)
+
+class ThirdCertificateUpload(FileUpload):
+    """Third Certificate upload viewlet.
+    """
+    grok.order(2)
+    label = _(u'Third Certificate')
+    title = _(u'Third Certificate Scan')
+    mus = 1024 * 150
+    download_name = u'certificate3'
+
+class CertificateImage(Image):
+    """Renders Third Certificate scan.
+    """
+    grok.name('certificate3')
+    download_name = u'certificate3'
 
 # Evidence of Name
@@ -190,5 +297,4 @@
     mus = 1024 * 150
     download_name = u'evid'
-    tab_redirect = '?tab2'
 
 class EvidenceOfNameImage(Image):