Index: main/waeup.kofa/trunk/src/waeup/kofa/locales/de/LC_MESSAGES/zope.po
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/locales/de/LC_MESSAGES/zope.po	(revision 8135)
+++ main/waeup.kofa/trunk/src/waeup/kofa/locales/de/LC_MESSAGES/zope.po	(revision 8141)
@@ -2,5 +2,5 @@
 msgstr ""
 "Project-Id-Version: WAeUP.KOFA\n"
-"PO-Revision-Date: 2012-04-03 09:28+0100\n"
+"PO-Revision-Date: 2012-04-13 10:21+0100\n"
 "Last-Translator: Henrik Bettermann <henrik@waeup.org>\n"
 "Language-Team: WAeUP Germany <henrik@waeup.org>\n"
@@ -49,2 +49,10 @@
 msgstr "--"
 
+#: src/zope/app/form/browser/boolwidgets.py:121
+msgid "True"
+msgstr "ja"
+
+#: src/zope/app/form/browser/boolwidgets.py:122
+msgid "False"
+msgstr "nein"
+
Index: main/waeup.kofa/trunk/src/waeup/kofa/locales/en/LC_MESSAGES/zope.po
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/locales/en/LC_MESSAGES/zope.po	(revision 8135)
+++ main/waeup.kofa/trunk/src/waeup/kofa/locales/en/LC_MESSAGES/zope.po	(revision 8141)
@@ -2,5 +2,5 @@
 msgstr ""
 "Project-Id-Version: WAeUP.KOFA\n"
-"PO-Revision-Date: 2012-04-03 08:19+0100\n"
+"PO-Revision-Date: 2012-04-13 10:18+0100\n"
 "Last-Translator: Henrik Bettermann <henrik@waeup.org>\n"
 "Language-Team: WAeUP Germany <henrik@waeup.org>\n"
@@ -49,2 +49,10 @@
 msgstr "--"
 
+#: src/zope/app/form/browser/boolwidgets.py:121
+msgid "True"
+msgstr "yes"
+
+#: src/zope/app/form/browser/boolwidgets.py:122
+msgid "False"
+msgstr "no"
+
Index: main/waeup.kofa/trunk/src/waeup/kofa/locales/zope.pot
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/locales/zope.pot	(revision 8135)
+++ main/waeup.kofa/trunk/src/waeup/kofa/locales/zope.pot	(revision 8141)
@@ -47,2 +47,10 @@
 msgid "sequence-value-is-empty"
 msgstr ""
+
+#: src/zope/app/form/browser/boolwidgets.py:121
+msgid "True"
+msgstr ""
+
+#: src/zope/app/form/browser/boolwidgets.py:122
+msgid "False"
+msgstr ""
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 8135)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 8141)
@@ -710,4 +710,18 @@
 
     @property
+    def translated_values(self):
+        lang = self.request.cookies.get('kofa.language')
+        for value in self.context.values():
+            import pdb; pdb.set_trace()
+            value_dict = value.__dict__
+            value_dict['mandatory'] = translate(str(value.mandatory), 'zope',
+                target_language=lang)
+            value_dict['carry_over'] = translate(str(value.carry_over), 'zope',
+                target_language=lang)
+            value_dict['automatic'] = translate(str(value.automatic), 'zope',
+                target_language=lang)
+            yield value_dict
+
+    @property
     def label(self):
         # Here we know that the cookie has been set
@@ -753,5 +767,5 @@
         level_title = translate(self.context.level_title, 'waeup.kofa',
             target_language=lang)
-        return translate(_('Course Registration Slip  '),
+        return translate(_('Course Registration Slip'),
             'waeup.kofa', target_language=portal_language) \
             + ' %s' % level_title
@@ -780,5 +794,6 @@
                          (Cred, 'credits', 1.5),
                          (Mand, 'mandatory', 1.5),
-                         (Score, 'score', 1.5),('Auto', 'automatic', 1.5)
+                         (Score, 'score', 1.5),
+                         #('Auto', 'automatic', 1.5)
                          ],
             tabledata=tabledata)
@@ -910,5 +925,5 @@
     label = _('Add course ticket')
     form_fields = grok.AutoFields(ICourseTicketAdd).omit(
-        'grade', 'score', 'automatic', 'carry_over')
+        'score', 'automatic', 'carry_over')
     pnav = 4
 
@@ -918,4 +933,5 @@
         course = data['course']
         ticket.automatic = False
+        ticket.carry_over = False
         ticket.code = course.code
         ticket.title = course.title
@@ -1849,5 +1865,5 @@
     grok.require('waeup.handleStudent')
     form_fields = grok.AutoFields(ICourseTicketAdd).omit(
-        'grade', 'score', 'mandatory', 'automatic', 'carry_over')
+        'score', 'mandatory', 'automatic', 'carry_over')
 
     def update(self):
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studylevelpage.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studylevelpage.pt	(revision 8135)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studylevelpage.pt	(revision 8141)
@@ -44,5 +44,5 @@
   </thead>
   <tbody>
-    <tr tal:repeat="value context/values" class="gradeC">
+    <tr tal:repeat="value view/translated_values" class="gradeC">
       <td tal:content="value/semester">SEMESTER</td>
       <td> <a tal:attributes="href value/__name__">
@@ -54,5 +54,5 @@
       <td tal:content="value/credits">CREDITS</td>
       <td tal:content="value/mandatory">MANDATORY</td>
-      <td tal:content="value/score">SCORE</td>
+      <td tal:content="value/score|nothing">SCORE</td>
       <td tal:content="value/carry_over">CO</td>
       <td tal:content="value/automatic">AUTO</td>
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/studycourse.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/studycourse.py	(revision 8135)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/studycourse.py	(revision 8141)
@@ -64,4 +64,5 @@
                 ticket.passmark = val.course.passmark
                 ticket.semester = val.course.semester
+                ticket.carry_over = False
                 self[str(studylevel.level)][ticket.code] = ticket
         # Collect carry-over courses in base levels (not in repeating levels)
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/utils.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/utils.py	(revision 8135)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/utils.py	(revision 8141)
@@ -77,4 +77,5 @@
     The returned snippet is unicode type.
     """
+    portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
     if not isinstance(text, unicode):
         if isinstance(text, basestring):
@@ -82,4 +83,7 @@
         else:
             text = unicode(text)
+    # Mainly for boolean values we need our customized
+    # localisation of the zope domain
+    text = translate(text, 'zope', target_language=portal_language)
     text = text.replace('</div>', '<br /></div>')
     tag1 = u'<font color="%s" size="%d">' % (color, size)
@@ -335,7 +339,8 @@
         data.extend(docs_as_flowables(view, portal_language))
 
-        # Insert content table on second page
+        # Insert content table (optionally on second page)
         if tabledata and tableheader:
-            data.append(PageBreak())
+            #data.append(PageBreak())
+            data.append(Spacer(1, 20))
             data.append(Paragraph(view.content_title, style["Heading3"]))
             contenttable = render_table_data(tableheader,tabledata)